package org.jeecg.modules.ctop.job;

import cn.com.ctop.common.module.entity.CtopOauthToken;
import cn.com.ctop.common.module.service.ICtopOauthTokenService;
import cn.com.ctop.common.module.utils.CtopAdConstant;
import cn.com.ctop.toutiao.modules.material.service.IByteDanceAdvertiserDataService;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.util.DateUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * DONE
 * 头条当日计划素材获取任务
 */
@Slf4j
public class BytedancePlanRealTimeLoadJob implements Job {
    @Autowired
    private ICtopOauthTokenService tokenService;
    static ExecutorService executorService = null;
    @Autowired
    private IByteDanceAdvertiserDataService advertiserDataService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {


        Thread thread = new Thread() {
            @Override
            public void run() {
                //1:查询当日数据
                List<CtopOauthToken> tokens = tokenService.getTokenListByType(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE);
                executorService = Executors.newFixedThreadPool(4);
                String nowDate = DateUtils.formatDate();
                tokens.forEach(token -> {
                    executorService.submit(new Runnable() {
                        @Override
                        public void run() {
                            try {
                                //1：获取当日广告计划数据
                                advertiserDataService.getAdvertiserPlan(token, "", nowDate, nowDate);
                            } catch (Exception e) {
                                e.printStackTrace();
                            } finally {
                            }
                        }
                    });
                });
                log.info("头条全量计划数据获取完成");
            }

        };
        thread.start();
    }


}
